%% unit tests of MPI_Reduce
disp('function is working if all err* values are 0'); 

MPI_Init; % Initialize MPI.
comm = MPI_COMM_WORLD; % Create communicator.
comm_size = MPI_Comm_size(comm); % Get size and rank.
my_rank = MPI_Comm_rank(comm);
SOURCE = 0;

scalars = rand(1,comm_size);
matrices = randn(10,10,comm_size);
[scalars, matrices] = MPI_Bcast(SOURCE, 1, comm, scalars, matrices);

scalar_sum = sum(scalars);
matrix_sum = sum(matrices,3);

[new_s_sum, new_m_sum] = MPI_Reduce(SOURCE, 2, comm, @MPI_SUM, ...
   scalars(my_rank+1), matrices(:,:,my_rank+1));
if my_rank == SOURCE
    err_s_sum = scalar_sum - new_s_sum
    err_m_sum = sum(sum((matrix_sum - new_m_sum).^2))
end

ss = MPI_Reduce(SOURCE, 3, comm, @MPI_SUM, my_rank)
if my_rank == SOURCE
    err_ss = ss - sum(0:comm_size-1)
end

pp = MPI_Reduce(SOURCE, 4, comm, @MPI_PROD, scalars(my_rank+1));
if my_rank == SOURCE
    err_pp = pp - prod(scalars)
end

% ? = MPI_Reduce(SOURCE, 5, comm, @MPI_MIN, ?);
% ? = MPI_Reduce(SOURCE, 6, comm, @MPI_MAX, ?);

array = MPI_Reduce(SOURCE, 6, comm, @MPI_CAT1, (my_rank+1)*eye(3));
if my_rank == SOURCE
    err_array = norm(array - kron((1:comm_size)', eye(3)))
end

MPI_Finalize;
